import 'firebase/auth';
import 'firebase/database';
import { MemoryStream, Stream } from 'xstream';
import { FirebaseAction } from './actions';
import { User as FirebaseUser, auth as firebaseAuth } from 'firebase/app';
export interface ActionResponse {
    name?: string;
    stream: Stream<any>;
}
export interface FirebaseConfig {
    apiKey: string;
    authDomain: string;
    databaseURL: string;
    messagingSenderId: string;
    projectId: string;
    storageBucket: string;
}
export interface ReferenceSource {
    child: (path: string) => ReferenceSource;
    events: EventLookup;
    value: MemoryStream<any>;
}
export interface ResultStream {
    action: FirebaseAction;
}
export declare type ResultMemoryStream = MemoryStream<any> & ResultStream;
export interface FirebaseSource {
    auth: {
        authState: MemoryStream<FirebaseUser | null>;
        currentUser: MemoryStream<FirebaseUser | null>;
        idToken: MemoryStream<FirebaseUser | null>;
        providersForEmail: (email: string) => MemoryStream<string[]>;
        redirectResult: MemoryStream<firebaseAuth.UserCredential>;
    };
    database: {
        ref: (path: string) => ReferenceSource;
        refFromURL: (url: string) => ReferenceSource;
    };
    select: (category: string) => Stream<any>;
}
export declare type EventLookup = (eventType: string) => MemoryStream<any>;
export declare type FirebaseDriver = (action$: Stream<FirebaseAction>) => FirebaseSource;
export declare function makeFirebaseDriver(config: FirebaseConfig, appName?: string): FirebaseDriver;
